/*#########################################################################
#                                                                         #
#   Simple script shamelessly recopied from:                              #
#                                                                         #
#   Copyright                                                             #
#                                                                         #
#   (C)  2010 Anselmo Lacerda Silveira de Melo <anselmolsm@gmail.com>     #
#   (C)  2010 Emile de Weerd <mederel+radionederland@gmail.com>           #
#   (C)  2009 MetalByte <emetalbyte@gmail.com>                            #
#   (C)  2009 Àlvar Cuevas i Fajardo <alvar@cuevas.cat>                   #
#   (C)  2008 Eirik Johansen Bjørgan  <eirikjbj@gmail.com>                #      
#   (C)  2008 Peter ZHOU <peterzhoulei@gmail.com>                         #
#   (C)  2008 Mark Kretschmann <kretschmann@kde.org>                      #
#   (C)  2007, 2008 Nikolaj Hald Nielsen  <nhnFreespirit@gmail.com>       #
#                                                                         #
#   This program is free software; you can redistribute it and/or modify  #
#   it under the terms of the GNU General Public License as published by  #
#   the Free Software Foundation; either version 2 of the License, or     #
#   (at your option) any later version.                                   #
#                                                                         #
#   This program is distributed in the hope that it will be useful,       #
#   but WITHOUT ANY WARRANTY; without even the implied warranty of        #
#   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the         #
#   GNU General Public License for more details.                          #
#                                                                         #
#   You should have received a copy of the GNU General Public License     #
#   along with this program; if not, write to the                         #
#   Free Software Foundation, Inc.,                                       #
#   51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.         #
##########################################################################*/

Importer.loadQtBinding("qt.core");
Importer.loadQtBinding("qt.gui");

function Station( name, url, description )
{
    this.name = name;
    this.url = url;
    this.description = description;
}

categories = new Object;

categories["Holiday Smooth Jazz"]=new Array ( 
        new Station( "Holiday Smooth Jazz", "http://listen.jazzradio.com/public1/holidaysmoothjazz.pls", "Holiday Smooth Jazz favorites!") );
categories["Holiday Jazz"]=new Array ( 
        new Station( "Holiday Jazz", "http://listen.jazzradio.com/public1/holidayjazz.pls", "Enjoy the season with this selection of holiday-themed jazz tunes.") );
categories["Bass Jazz"]=new Array ( 
        new Station( "Bass Jazz", "http://listen.jazzradio.com/public1/bassjazz.pls", "Your favorite double bass jazz!") );
categories["Vibraphone Jazz"]=new Array ( 
        new Station( "Vibraphone Jazz", "http://listen.jazzradio.com/public1/vibraphonejazz.pls", "Enjoy your favorite vibraphone hits.") );
categories["Smooth Jazz 24'7"]=new Array ( 
        new Station( "Smooth Jazz 24'7", "http://listen.jazzradio.com/public1/smoothjazz247.pls", "Keeping the jazz flowing with the hottest smooth jazz talent around.") );
categories["Current Jazz"]=new Array ( 
        new Station( "Current Jazz", "http://listen.jazzradio.com/public1/currentjazz.pls", "Enjoy jazz from the currently active talent.") );
categories["Gypsy Jazz"]=new Array ( 
        new Station( "Gypsy Jazz", "http://listen.jazzradio.com/public1/gypsyjazz.pls", "Celebrating the sounds made popular by the likes of Django Reinhardt.") );
categories["Paris Café"]=new Array ( 
        new Station( "Paris Café", "http://listen.jazzradio.com/public1/pariscafe.pls", "Sit on the patio, enjoy the music, and watch the people go by.") );
categories["Trumpet Jazz"]=new Array ( 
        new Station( "Trumpet Jazz", "http://listen.jazzradio.com/public1/trumpetjazz.pls", "Jazz from the genre's best trumpeters.") );
categories["Saxophone Jazz"]=new Array ( 
        new Station( "Saxophone Jazz", "http://listen.jazzradio.com/public1/saxophonejazz.pls", "One of jazz's most popular instruments, from bebop to today.") );
categories["Cool Jazz"]=new Array ( 
        new Station( "Cool Jazz", "http://listen.jazzradio.com/public1/cooljazz.pls", "Chilled sounds from the West Coast including Brubeck, Davis, & Konitz.") );
categories["Classic Jazz"]=new Array ( 
        new Station( "Classic Jazz", "http://listen.jazzradio.com/public1/classicjazz.pls", "Jazz from where it began. Hot jazz, early swing, and the solo greats.") );
categories["Mellow Jazz"]=new Array ( 
        new Station( "Mellow Jazz", "http://listen.jazzradio.com/public1/mellowjazz.pls", "Our special mix of Jazz, from classics to contemporary.") );
categories["Smooth Jazz"]=new Array ( 
        new Station( "Smooth Jazz", "http://listen.jazzradio.com/public1/smoothjazz.pls", "The smoothest jazz of its kind you'll ever hear, really.") );
categories["Smooth Lounge"]=new Array ( 
        new Station( "Smooth Lounge", "http://listen.jazzradio.com/public1/smoothlounge.pls", "Relax and unwind with the smoothest lounge vibes.") );
categories["Straight-Ahead"]=new Array ( 
        new Station( "Straight-Ahead", "http://listen.jazzradio.com/public1/straightahead.pls", "Today's best artists keep the classics alive and push the boundaries.") );
categories["Piano Jazz"]=new Array ( 
        new Station( "Piano Jazz", "http://listen.jazzradio.com/public1/pianojazz.pls", "Enjoy these historic and contemporary piano jazz masters.") );
categories["Guitar Jazz"]=new Array ( 
        new Station( "Guitar Jazz", "http://listen.jazzradio.com/public1/guitarjazz.pls", "Hear guitar jazz legends such as Wes Montgomery, Jim Hall, & Les Paul.") );
categories["Bebop"]=new Array ( 
        new Station( "Bebop", "http://listen.jazzradio.com/public1/bebop.pls", "Swinging to the sounds of bebop and straight-ahead jazz.") );
categories["Hard Bop"]=new Array ( 
        new Station( "Hard Bop", "http://listen.jazzradio.com/public1/hardbop.pls", "Serious head-bobbing charts from Art Blakey, Miles Davis, and more.") );
categories["Piano Trios"]=new Array ( 
        new Station( "Piano Trios", "http://listen.jazzradio.com/public1/pianotrios.pls", "Jazz pianist, bassist and drummer - a perfect recipe for great jazz.") );
categories["Bossa Nova"]=new Array ( 
        new Station( "Bossa Nova", "http://listen.jazzradio.com/public1/bossanova.pls", "Sweet sounds of bossa nova and the flavors of Brazil.") );
categories["Fusion Lounge"]=new Array ( 
        new Station( "Fusion Lounge", "http://listen.jazzradio.com/public1/fusionlounge.pls", "Amazing combination of jazz, lounge, bossa nova, and more.") );
categories["Contemporary Vocals"]=new Array ( 
        new Station( "Contemporary Vocals", "http://listen.jazzradio.com/public1/vocaljazz.pls", "Hear today's jazz singers reinvent and create new standards.") );
categories["Smooth Vocals"]=new Array ( 
        new Station( "Smooth Vocals", "http://listen.jazzradio.com/public1/smoothvocals.pls", "When only the best of vocal smooth jazz will do.") );
categories["Vocal Legends"]=new Array ( 
        new Station( "Vocal Legends", "http://listen.jazzradio.com/public1/vocallegends.pls", "Vocal legends like Ella Fitzgerald, Frank Sinatra, Billie Holiday & more.") );
categories["Smooth Uptempo"]=new Array ( 
        new Station( "Smooth Uptempo", "http://listen.jazzradio.com/public1/smoothuptempo.pls", "Upbeat smooth jazz grooves from your favorite artists.") );
categories["Swing & Big Band"]=new Array ( 
        new Station( "Swing & Big Band", "http://listen.jazzradio.com/public1/swingnbigband.pls", "The best sounds of the swing era of the 30s & 40s") );
categories["Latin Jazz"]=new Array ( 
        new Station( "Latin Jazz", "http://listen.jazzradio.com/public1/latinjazz.pls", "Paquito D'Rivera, Mongo Santamaria, & many other Latin legends.") );
categories["Timeless Classics"]=new Array ( 
        new Station( "Timeless Classics", "http://listen.jazzradio.com/public1/timelessclassics.pls", "A unique mix of early jazz, swing, big band, and other classic tunes.") );
categories["Sinatra Style"]=new Array ( 
        new Station( "Sinatra Style", "http://listen.jazzradio.com/public1/sinatrastyle.pls", "For fans of Frank Sinatra, this channel is full of great American standards.") );
categories["Blues Rock"]=new Array ( 
        new Station( "Blues Rock", "http://listen.jazzradio.com/public1/bluesrock.pls", "A fusion of Blues and Rock.") );
categories["Blues"]=new Array ( 
        new Station( "Blues", "http://listen.jazzradio.com/public1/blues.pls", "Selected picks of the very best of blues.") );
categories["Avant-Garde"]=new Array ( 
        new Station( "Avant-Garde", "http://listen.jazzradio.com/public1/avantgarde.pls", "The shape of jazz from Ornette Coleman, Sun-Ra, and many others.") );


images = new Object;
images["Holiday Smooth Jazz"]="holidaysmoothjazz.png";
images["Holiday Jazz"]="holidayjazz.png";
images["Bass Jazz"]="bassjazz.png";
images["Vibraphone Jazz"]="vibraphonejazz.png";
images["Smooth Jazz 24'7"]="smoothjazz247.png";
images["Current Jazz"]="currentjazz.png";
images["Gypsy Jazz"]="gypsyjazz.png";
images["Paris Café"]="pariscafe.png";
images["Trumpet Jazz"]="trumpetjazz.png";
images["Saxophone Jazz"]="saxophonejazz.png";
images["Cool Jazz"]="cooljazz.png";
images["Classic Jazz"]="classicjazz.png";
images["Mellow Jazz"]="mellowjazz.png";
images["Smooth Jazz"]="smoothjazz.png";
images["Smooth Lounge"]="smoothlounge.png";
images["Straight-Ahead"]="straightahead.png";
images["Piano Jazz"]="pianojazz.png";
images["Guitar Jazz"]="guitarjazz.png";
images["Bebop"]="bebop.png";
images["Hard Bop"]="hardbop.png";
images["Piano Trios"]="pianotrios.png";
images["Bossa Nova"]="bossanova.png";
images["Fusion Lounge"]="fusionlounge.png";
images["Contemporary Vocals"]="vocaljazz.png";
images["Smooth Vocals"]="smoothvocals.png";
images["Vocal Legends"]="vocallegends.png";
images["Smooth Uptempo"]="smoothuptempo.png";
images["Swing & Big Band"]="swingnbigband.png";
images["Latin Jazz"]="latinjazz.png";
images["Timeless Classics"]="timelessclassics.png";
images["Sinatra Style"]="sinatrastyle.png";
images["Blues Rock"]="bluesrock.png";
images["Blues"]="blues.png";
images["Avant-Garde"]="avantgarde.png";


function JazzRadios()
{
    // last argument is the filter box
    ScriptableServiceScript.call( this, "JAZZRADIO.com", 2, "Enjoy great jazz music", "Presenting jazz radio channels for your enjoyment. Listen for free and enjoy countless hours of the best jazz music around.", true );
    Amarok.debug( "ok." );
}

function onConfigure()
{
    Amarok.alert( "This script doesn't require configuration." );
}

function onPopulating( level, callbackData, filter )
{
	filter = filter.toLowerCase().replace("%20","");
	
    if ( level == 1 ) 
    {
        for( att in categories )
        {
	  			if(filter.length > 0)
			{
				var hasItems = false;
				var stationArray = categories[att];
				for ( i = 0; i < stationArray.length; i++ )
				{
					if(stationArray[i].name.toLowerCase().indexOf(filter) != -1)
					{
						hasItems = true;
						break;
					}
				}
				if(!hasItems) continue;
			}
			
            var cover = Amarok.Info.scriptPath() + "/" + images[att];
            Amarok.debug ("att: " + att + ", " + categories[att].name);
      
            item = Amarok.StreamItem;
	    item.level = 1;
	    item.callbackData = att;
	    item.itemName = att;
	    item.playableUrl = "";
	    item.infoHtml = "";
            item.coverUrl = cover;
	    script.insertItem( item );

        }
        script.donePopulating();

    }
    else if ( level == 0 ) 
    {
        Amarok.debug( " Compiling stations..." );
	//add the station streams as leaf nodes

        var stationArray = categories[callbackData];

	for ( i = 0; i < stationArray.length; i++ )
	{
                var cover = Amarok.Info.scriptPath() + "/" + images[callbackData];
		item = Amarok.StreamItem;
		item.level = 0;
		item.callbackData = "";
		item.itemName = stationArray[i].name;
		item.playableUrl = stationArray[i].url;
		item.album = callbackData;
		item.infoHtml = stationArray[i].description;
                item.artist = "Radio Stream";
                item.coverUrl = cover;
		script.insertItem( item );
	}
	script.donePopulating();
    }
}

function onCustomize() {
    var currentDir = Amarok.Info.scriptPath() + "/";
    var iconPixmap = new QPixmap(currentDir+"icon.png");
    script.setIcon(iconPixmap);
}

Amarok.configured.connect( onConfigure );

script = new JazzRadios();
script.populate.connect( onPopulating );
script.customize.connect( onCustomize );
